#include <GDIPlus.au3>
#include <Color.au3>

_GDIPlus_Startup()

$hImage1 = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\1.png")
$hImage2 = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\2.png")
$hImage3 = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\3.png")

Local $aColors[_GDIPlus_ImageGetWidth($hImage2)]
For $x = 0 To _GDIPlus_ImageGetWidth($hImage2) - 1
	$aColors[$x] = _GDIPlus_BitmapGetPixel($hImage2, $x, 0)
Next

For $y = _GDIPlus_ImageGetHeight($hImage1) - 1 To 0 Step -1
	If _GDIPlus_BitmapGetPixel($hImage1, 0, $y) = $aColors[0] Then
		$bFound = True

		For $x = 0 To _GDIPlus_ImageGetWidth($hImage1) - 1
			$cIm1 = _GDIPlus_BitmapGetPixel($hImage1, $x, $y)

			;Farbtoleranz wichtig bei JPG-Bildern.
			;Nimmt man die Bilder als PNG auf (verlustfrei) so kann man diese komplett weglassen und auf identische Pixel prüfen (sicherer!)
			If Sqrt((_ColorGetRed($cIm1) - _ColorGetRed($aColors[$x]))^2 + (_ColorGetBlue($cIm1) - _ColorGetBlue($aColors[$x]))^2 + (_ColorGetGreen($cIm1) - _ColorGetGreen($aColors[$x]))^2) / Sqrt(255^2 + 255^2 + 255^2) > 0.5 Then
				$bFound = False
				ExitLoop
			EndIf
		Next

		If $bFound Then ExitLoop
	EndIf
Next

ConsoleWrite("Positioniere Bild 2 in Bild 1 an Stelle Y = " & $y & @CRLF)

If Not $bFound Then Exit MsgBox(16, "", "Nicht gefunden.")
Local $iY1 = $y


Local $aColors[_GDIPlus_ImageGetWidth($hImage3)]
For $x = 0 To _GDIPlus_ImageGetWidth($hImage3) - 1
	$aColors[$x] = _GDIPlus_BitmapGetPixel($hImage3, $x, 0)
Next

For $y = _GDIPlus_ImageGetHeight($hImage2) - 1 To 0 Step - 1
	If _GDIPlus_BitmapGetPixel($hImage2, 0, $y) = $aColors[0] Then
		$bFound = True

		For $x = 0 To _GDIPlus_ImageGetWidth($hImage2) - 1
			$cIm1 = _GDIPlus_BitmapGetPixel($hImage2, $x, $y)

			If Sqrt((_ColorGetRed($cIm1) - _ColorGetRed($aColors[$x]))^2 + (_ColorGetBlue($cIm1) - _ColorGetBlue($aColors[$x]))^2 + (_ColorGetGreen($cIm1) - _ColorGetGreen($aColors[$x]))^2) / Sqrt(255^2 + 255^2 + 255^2) > 0.5 Then
				$bFound = False
				ExitLoop
			EndIf
		Next

		If $bFound Then ExitLoop
	EndIf
Next

ConsoleWrite("Positioniere Bild 3 in Bild 2 an Stelle Y = " & $y & @CRLF)

If Not $bFound Then Exit MsgBox(16, "", "Nicht gefunden.")
Local $iY2 = $y

$hMergedBitmap = _GDIPlus_BitmapCreateFromScan0(_GDIPlus_ImageGetWidth($hImage1), _GDIPlus_ImageGetHeight($hImage1) + _GDIPlus_ImageGetHeight($hImage2) + _GDIPlus_ImageGetHeight($hImage3) _
						- (_GDIPlus_ImageGetHeight($hImage1) - $iY1) - (_GDIPlus_ImageGetHeight($hImage2) - $iY2))

$hGraphics = _GDIPlus_ImageGetGraphicsContext($hMergedBitmap)
_GDIPlus_GraphicsDrawImage($hGraphics, $hImage1, 0, 0)
_GDIPlus_GraphicsDrawImage($hGraphics, $hImage2, 0, $iY1)
_GDIPlus_GraphicsDrawImage($hGraphics, $hImage3, 0, _GDIPlus_ImageGetHeight($hMergedBitmap) - _GDIPlus_ImageGetHeight($hImage3))

_GDIPlus_GraphicsDispose($hGraphics)
_GDIPlus_ImageSaveToFile($hMergedBitmap, "neu.png")
_GDIPlus_BitmapDispose($hMergedBitmap)

_GDIPlus_Shutdown()